diff --git a/src/zabbix_server/vmware/vmware.h b/src/zabbix_server/vmware/vmware.h
index 8a7962c6c99..27be194146e 100644
--- a/src/zabbix_server/vmware/vmware.h
+++ b/src/zabbix_server/vmware/vmware.h
@@ -31,11 +31,6 @@
 
 #define ZBX_VMWARE_STATE_MASK		0x0FF
 
-/* the vmware performance counter state */
-#define ZBX_VMWARE_COUNTER_NEW		0x00
-#define ZBX_VMWARE_COUNTER_READY	0x01
-#define ZBX_VMWARE_COUNTER_UPDATING	0x10
-
 #define ZBX_VMWARE_EVENT_KEY_UNINITIALIZED	__UINT64_C(0xffffffffffffffff)
 
 typedef struct
@@ -48,6 +43,8 @@ zbx_str_uint64_pair_t;
 ZBX_PTR_VECTOR_DECL(str_uint64_pair, zbx_str_uint64_pair_t)
 int	zbx_str_uint64_pair_name_compare(const void *p1, const void *p2);
 
+#define UC(v)	((unsigned char)v)
+
 /* performance counter data */
 typedef struct
 {
@@ -59,8 +56,22 @@ typedef struct
 	/*    pair->value - value                   */
 	zbx_vector_str_uint64_pair_t	values;
 
-	/* the counter state, see ZBX_VMAWRE_COUNTER_* defines */
+#define ZBX_VMWARE_COUNTER_NEW		UC(0x00)
+#define ZBX_VMWARE_COUNTER_READY	UC(0x01)
+#define ZBX_VMWARE_COUNTER_UPDATING	UC(0x02)
+#define ZBX_VMWARE_COUNTER_CUSTOM	UC(0x10)
+#define ZBX_VMWARE_COUNTER_ACCEPTABLE	UC(0x20)
+#define ZBX_VMWARE_COUNTER_NOTSUPPORTED	UC(0x40)
+
+#define ZBX_VMWARE_COUNTER_STATE_MASK	0xF0
+	/* the vmware performance counter state */
 	unsigned char			state;
+
+	/* time of last attempt of poller to use data */
+	time_t				last_used;
+
+	/* alternate query instance (for the case when 'entity' query is TOTAL) */
+	char				*query_instance;
 }
 zbx_vmware_perf_counter_t;
 
@@ -73,15 +84,19 @@ typedef struct
 	/* entity id */
 	char			*id;
 
+#define ZBX_VMWARE_PERF_INTERVAL_UNKNOWN	0
+#define ZBX_VMWARE_PERF_INTERVAL_NONE		-1
 	/* the performance counter refresh rate */
 	int			refresh;
 
 	/* timestamp when the entity was queried last time */
-	int			last_seen;
+	time_t			last_seen;
 
 	/* the performance counters to monitor */
 	zbx_vector_ptr_t	counters;
 
+#define ZBX_VMWARE_PERF_QUERY_ALL		"*"
+#define ZBX_VMWARE_PERF_QUERY_TOTAL		""
 	/* the performance counter query instance name */
 	char			*query_instance;
 
@@ -92,8 +107,34 @@ zbx_vmware_perf_entity_t;
 
 typedef struct
 {
-	zbx_uint64_t	partitionid;
+	char		*ssd;
+	char		*local_disk;
+	unsigned int	block_size;
+	unsigned int	block;
+}
+zbx_vmware_vsandiskinfo_t;
+
+typedef struct
+{
+	char				*diskname;
+	char				*ds_uuid;
+	char				*operational_state;
+	char				*lun_type;
+	int				queue_depth;
+	char				*model;
+	char				*vendor;
+	char				*revision;
+	char				*serial_number;
+	zbx_vmware_vsandiskinfo_t	*vsan;
+}
+zbx_vmware_diskinfo_t;
+
+ZBX_PTR_VECTOR_DECL(vmware_diskinfo, zbx_vmware_diskinfo_t *)
+
+typedef struct
+{
 	char		*diskname;
+	zbx_uint64_t	partitionid;
 }
 zbx_vmware_diskextent_t;
 
@@ -113,6 +154,7 @@ typedef struct
 	char				*uuid;
 	char				*name;
 	char				*id;
+	char				*type;
 	zbx_uint64_t			capacity;
 	zbx_uint64_t			free_space;
 	zbx_uint64_t			uncommitted;
@@ -266,6 +308,7 @@ typedef struct
 	zbx_vector_ptr_t		vms;
 	zbx_vector_vmware_pnic_t	pnics;
 	zbx_vector_str_t		alarm_ids;
+	zbx_vector_vmware_diskinfo_t	diskinfo;
 }
 zbx_vmware_hv_t;
 
@@ -283,6 +326,7 @@ typedef struct
 	char			*id;
 	char			*name;
 	char			*status;
+	zbx_vector_str_t	dss_uuid;
 	zbx_vector_str_t	alarm_ids;
 }
 zbx_vmware_cluster_t;
@@ -381,11 +425,11 @@ typedef struct
 	/* the result of query */
 	char				*value;
 
-#define ZBX_VMWARE_CQ_NEW	0
-#define ZBX_VMWARE_CQ_READY	1
-#define ZBX_VMWARE_CQ_ERROR	2
-#define ZBX_VMWARE_CQ_PAUSED	4
-#define ZBX_VMWARE_CQ_SEPARATE	8
+#define ZBX_VMWARE_CQ_NEW		UC(0x01)
+#define ZBX_VMWARE_CQ_READY		UC(0x02)
+#define ZBX_VMWARE_CQ_ERROR		UC(0x04)
+#define ZBX_VMWARE_CQ_PAUSED		UC(0x08)
+#define ZBX_VMWARE_CQ_SEPARATE		UC(0x10)
 	/* the state of query */
 	unsigned char			state;
 
@@ -443,10 +487,10 @@ typedef struct
 	/* the service state - see ZBX_VMWARE_STATE_* defines */
 	int				state;
 
-	int				lastcheck;
+	time_t				lastcheck;
 
 	/* The last vmware service access time. If a service is not accessed for a day it is removed */
-	int				lastaccess;
+	time_t				lastaccess;
 
 	/* the vmware service instance version */
 	char				*version;
@@ -454,6 +498,7 @@ typedef struct
 	/* the vmware service instance version numeric */
 	unsigned short			major_version;
 	unsigned short			minor_version;
+	unsigned short			patch_version;
 
 	/* the vmware service instance fullname */
 	char				*fullname;
@@ -481,9 +526,6 @@ typedef struct
 }
 zbx_vmware_service_t;
 
-#define ZBX_VMWARE_PERF_INTERVAL_UNKNOWN	0
-#define ZBX_VMWARE_PERF_INTERVAL_NONE		-1
-
 /* the vmware collector data */
 typedef struct
 {
@@ -496,7 +538,7 @@ zbx_vmware_t;
 
 typedef struct
 {
-	int			nextcheck;
+	time_t			nextcheck;
 #define ZBX_VMWARE_UPDATE_CONF		1
 #define ZBX_VMWARE_UPDATE_PERFCOUNTERS	2
 #define ZBX_VMWARE_UPDATE_REST_TAGS	3
@@ -546,7 +588,7 @@ int	zbx_vmware_service_add_perf_counter(zbx_vmware_service_t *service, const cha
 zbx_vmware_perf_entity_t	*zbx_vmware_service_get_perf_entity(zbx_vmware_service_t *service, const char *type,
 		const char *id);
 
-zbx_vmware_cust_query_t *zbx_vmware_service_add_cust_query(zbx_vmware_service_t *service, const char *type,
+zbx_vmware_cust_query_t *zbx_vmware_service_add_cust_query(zbx_vmware_service_t *service, const char *soap_type,
 		const char *id, const char *key, zbx_vmware_custom_query_type_t query_type, const char *mode,
 		zbx_vector_custquery_param_t *query_params);
 zbx_vmware_cust_query_t	*zbx_vmware_service_get_cust_query(zbx_vmware_service_t *service, const char *type,
diff --git a/src/zabbix_server/vmware/vmware_manager.c b/src/zabbix_server/vmware/vmware_manager.c
index 0c93112a2ca..f4c9fd6a910 100644
--- a/src/zabbix_server/vmware/vmware_manager.c
+++ b/src/zabbix_server/vmware/vmware_manager.c
@@ -69,7 +69,7 @@ static const char	*vmware_job_type_string(zbx_vmware_job_t *job)
  * Return value: job for object or NULL                                       *
  *                                                                            *
  ******************************************************************************/
-static zbx_vmware_job_t	*vmware_job_get(zbx_vmware_t *vmw, int time_now)
+static zbx_vmware_job_t	*vmware_job_get(zbx_vmware_t *vmw, time_t time_now)
 {
 	zbx_binary_heap_elem_t	*elem;
 	zbx_vmware_job_t	*job = NULL;
@@ -151,7 +151,7 @@ out:
  *             time_now - [IN] the current time                               *
  *                                                                            *
  ******************************************************************************/
-static void	vmware_job_schedule(zbx_vmware_t *vmw, zbx_vmware_job_t *job, int time_now)
+static void	vmware_job_schedule(zbx_vmware_t *vmw, zbx_vmware_job_t *job, time_t time_now)
 {
 	zbx_binary_heap_elem_t	elem_new = {0, job};
 
@@ -236,7 +236,7 @@ ZBX_THREAD_ENTRY(vmware_thread, args)
 			}
 
 			services_updated += vmware_job_exec(job);
-			vmware_job_schedule(vmware, job, (int)time_now);
+			vmware_job_schedule(vmware, job, (time_t)time_now);
 		}
 
 		if (zbx_time() - time_now <= JOB_TIMEOUT)
diff --git a/src/zabbix_server/vmware/vmware_rest.c b/src/zabbix_server/vmware/vmware_rest.c
index 48d97daa742..bec34f87224 100644
--- a/src/zabbix_server/vmware/vmware_rest.c
+++ b/src/zabbix_server/vmware/vmware_rest.c
@@ -411,9 +411,14 @@ static int	vmware_service_rest_authenticate(const zbx_vmware_service_t *service,
 		goto out;
 	}
 
-	if ('"' != page->data[0] && FAIL == vmware_rest_response_open(page->data, NULL, error))
+	if (0 == page->offset)
 	{
-		*error = zbx_dsprintf(*error, "Authentication fail, %s.", *error);
+		*error = zbx_strdup(*error, "Cannot authenticate, received empty response.");
+		goto out;
+	}
+	else if ('"' != page->data[0] && FAIL == vmware_rest_response_open(page->data, NULL, error))
+	{
+		*error = zbx_dsprintf(*error, "Cannot authenticate, %s.", *error);
 		goto out;
 	}
 
@@ -508,6 +513,8 @@ static int	vmware_http_request(const char *fn_parent, CURL *easyhandle, const ch
 		*error = zbx_strdup(*error, curl_easy_strerror(err));
 		return FAIL;
 	}
+	else if (0 == page->offset)
+		*page->data = '\0';
 
 	if (NULL != fn_parent)
 		zabbix_log(LOG_LEVEL_TRACE, "%s() REST response: %s", fn_parent, page->data);
@@ -783,9 +790,9 @@ int	zbx_vmware_service_update_tags(zbx_vmware_service_t *service)
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() vc version:%s", __func__, service->version);
 
-	if (65 > service->major_version * 10 + service->minor_version)
+	if (702 > service->major_version * 100 + service->minor_version * 10 + service->patch_version)
 	{
-		error = zbx_strdup(error, "Tags are supported since vmware version 6.5.");
+		error = zbx_strdup(error, "Tags are supported since vmware version 7.0.2");
 		goto out;
 	}
 
diff --git a/tests/libs/zbxcommon/Makefile.am b/tests/libs/zbxcommon/Makefile.am
index 280a9d6cc7a..113b999e0f6 100644
--- a/tests/libs/zbxcommon/Makefile.am
+++ b/tests/libs/zbxcommon/Makefile.am
@@ -29,7 +29,8 @@ SERVER_tests = \
 	zbx_get_report_nextcheck \
 	zbx_ltrim_utf8 \
 	zbx_rtrim_utf8 \
-	zbx_get_week_number
+	zbx_get_week_number \
+	zbx_iso8601_utc
 endif
 
 noinst_PROGRAMS = $(SERVER_tests)
@@ -538,5 +539,20 @@ zbx_get_week_number_LDFLAGS = @SERVER_LDFLAGS@
 
 zbx_get_week_number_CFLAGS = $(COMMON_COMPILER_FLAGS)
 
+# zbx_iso8601_utc
+
+zbx_iso8601_utc_SOURCES = \
+	zbx_iso8601_utc.c \
+	$(COMMON_SRC_FILES)
+
+zbx_iso8601_utc_LDADD = \
+	$(COMMON_LIB_FILES)
+
+zbx_iso8601_utc_LDADD += @SERVER_LIBS@
+
+zbx_iso8601_utc_LDFLAGS = @SERVER_LDFLAGS@
+
+zbx_iso8601_utc_CFLAGS = $(COMMON_COMPILER_FLAGS)
+
 
 endif
diff --git a/tests/libs/zbxcommon/zbx_iso8601_utc.c b/tests/libs/zbxcommon/zbx_iso8601_utc.c
new file mode 100644
index 00000000000..6afd306aea3
--- /dev/null
+++ b/tests/libs/zbxcommon/zbx_iso8601_utc.c
@@ -0,0 +1,52 @@
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+#include "zbxmocktest.h"
+#include "zbxmockdata.h"
+#include "zbxmockassert.h"
+#include "zbxmockutil.h"
+#include <stdlib.h>
+
+void	zbx_mock_test_entry(void **state)
+{
+	const char	*param;
+	int		expected_ret, returned_ret;
+	time_t		ut;
+
+	ZBX_UNUSED(state);
+
+	param = zbx_mock_get_parameter_string("in.param");
+
+	expected_ret = zbx_mock_str_to_return_code(zbx_mock_get_parameter_string("out.return"));
+	returned_ret = zbx_iso8601_utc(param, &ut);
+
+	zbx_mock_assert_result_eq("zbx_iso8601_datetime()", expected_ret, returned_ret);
+
+	if (SUCCEED == returned_ret)
+	{
+		zbx_timespec_t	dt;
+		time_t		t_out;
+
+		if (ZBX_MOCK_SUCCESS != zbx_strtime_to_timespec(zbx_mock_get_parameter_string("out.datetime"), &dt))
+			fail_msg("Invalid date time format");
+
+		t_out = dt.sec;
+		zbx_mock_assert_time_eq("zbx_iso8601_datetime() incorrect parsing:", t_out, ut);
+	}
+}
diff --git a/ui/include/classes/data/CItemData.php b/ui/include/classes/data/CItemData.php
index 561ce8d7040..0931ef7486b 100644
--- a/ui/include/classes/data/CItemData.php
+++ b/ui/include/classes/data/CItemData.php
@@ -240,6 +240,7 @@ final class CItemData {
 			'vmware.datastore.alarms.get[<url>,<uuid>]',
 			'vmware.datastore.discovery[<url>]',
 			'vmware.datastore.hv.list[<url>,<datastore>]',
+			'vmware.datastore.perfcounter[<url>,<uuid>,<path>,<instance>]',
 			'vmware.datastore.property[<url>,<uuid>,<prop>]',
 			'vmware.datastore.read[<url>,<datastore>,<mode>]',
 			'vmware.datastore.size[<url>,<datastore>,<mode>]',
@@ -266,6 +267,7 @@ final class CItemData {
 			'vmware.hv.datastore.size[<url>,<uuid>,<datastore>,<mode>]',
 			'vmware.hv.datastore.write[<url>,<uuid>,<datastore>,<mode>]',
 			'vmware.hv.discovery[<url>]',
+			'vmware.hv.diskinfo.get[<url>,<uuid>]',
 			'vmware.hv.fullname[<url>,<uuid>]',
 			'vmware.hv.hw.cpu.freq[<url>,<uuid>]',
 			'vmware.hv.hw.cpu.model[<url>,<uuid>]',
@@ -1314,6 +1316,10 @@ final class CItemData {
 				'description' => _('VMware datastore hypervisors list, <url> - VMware service URL, <datastore> - datastore name'),
 				'value_type' => ITEM_VALUE_TYPE_TEXT
 			],
+			'vmware.datastore.perfcounter[<url>,<uuid>,<path>,<instance>]' => [
+				'description' => _('VMware datastore performance counter, <url> - VMware service URL, <id> - VMware datastore uuid, <path> - performance counter path, <instance> - performance counter instance'),
+				'value_type' => ITEM_VALUE_TYPE_FLOAT
+			],
 			'vmware.datastore.property[<url>,<uuid>,<prop>]' => [
 				'description' => _('VMware datastore property, <url> - VMware service URL, <uuid> - datastore name, <prop> - property path'),
 				'value_type' => ITEM_VALUE_TYPE_TEXT
@@ -1418,6 +1424,10 @@ final class CItemData {
 				'description' => _('Discovery of VMware hypervisors, <url> - VMware service URL. Returns JSON'),
 				'value_type' => ITEM_VALUE_TYPE_TEXT
 			],
+			'vmware.hv.diskinfo.get[<url>,<uuid>]' => [
+				'description' => _('Info about internal disks of hypervisor required for vmware.datastore.perfcounter, <url> - VMware service URL, <uuid> - VMware hypervisor host name. Returns JSON'),
+				'value_type' => ITEM_VALUE_TYPE_TEXT
+			],
 			'vmware.hv.fullname[<url>,<uuid>]' => [
 				'description' => _('VMware hypervisor name, <url> - VMware service URL, <uuid> - VMware hypervisor host name'),
 				'value_type' => ITEM_VALUE_TYPE_STR
@@ -1492,7 +1502,7 @@ final class CItemData {
 			],
 			'vmware.hv.perfcounter[<url>,<uuid>,<path>,<instance>]' => [
 				'description' => _('VMware hypervisor performance counter, <url> - VMware service URL, <uuid> - VMware hypervisor host name, <path> - performance counter path, <instance> - performance counter instance'),
-				'value_type' => null
+				'value_type' => ITEM_VALUE_TYPE_FLOAT
 			],
 			'vmware.hv.power[<url>,<uuid>,<max>]' => [
 				'description' => _('Power usage , <url> - VMware service URL, <uuid> - VMware hypervisor host name, <max> - Maximum allowed power usage'),
@@ -1664,7 +1674,7 @@ final class CItemData {
 			],
 			'vmware.vm.perfcounter[<url>,<uuid>,<path>,<instance>]' => [
 				'description' => _('VMware virtual machine performance counter, <url> - VMware service URL, <uuid> - VMware virtual machine host name, <path> - performance counter path, <instance> - performance counter instance'),
-				'value_type' => null
+				'value_type' => ITEM_VALUE_TYPE_FLOAT
 			],
 			'vmware.vm.powerstate[<url>,<uuid>]' => [
 				'description' => _('VMware virtual machine power state, <url> - VMware service URL, <uuid> - VMware virtual machine host name'),
